#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>


#define TRUE 1
#define FALSE 0

/* Function Prototypes */
char * getname(char * cp);
void printmessage(FILE * stream);
int getmessagelist(char * name, char * area, char * search_name);
int getmessage(char * name, char * area, int count);

const char PATH[] = "/var/lib/majordomo/archive"; 
/* const char PATH[] = "c:/nos/spool/mail/";  */
 

void stringtolower(char * string)
{
   int length, i;

   length = strlen(string);
   for (i=0; i<length; i++)
   {
       string[i] = tolower(string[i]);
   }
   return;
}


void printmessage(FILE * stream)
{
  char msg[255];

  while ( fgets(msg, sizeof(msg), stream) != NULL)
  {
   if (strncmp("From ", msg, 5) != 0)
      printf("%s",msg);
   else
      break;
  } 
}

int getmessage(char * area, char * name, int count)
{
   FILE *stream;
   char msg[655] = "";
   char from[255] = "";
   char subject[655] = "";
   char day[80] = "";
   char month[80] = "";
   char year[80] = "";             /*50*/
   char date[80] = "";
   char temp[655] = "";
   int  j;
   int i = 0;
   char * pt;


   sprintf(temp,"%s/%s/%s",PATH,area,name);
 /*  printf("[%s]  <hr>\n",temp); */
   if ((stream = fopen(temp, "r")) == NULL)
   {
      printf("getmessage::cannot open input file [%s].</ol>",temp);
      return 1;
   }





while ( fgets(msg, sizeof(msg), stream) != NULL)
  {

   /*  printf("%d/%s\n",strlen(msg),msg); */
     if (strncmp("From ", msg, 5) == 0 ) 
     {
           i++;
           day[0]     = '\0';  date[0] = '\0';
           from[0]    = '\0';  month[0] = '\0';
           subject[0] = '\0';  year[0]  = '\0'; 
           sscanf(msg,"From %s %s %s %s %s %s",temp,temp,month,day,temp,year);
           sprintf(date,"Date:    %2s%3s%-4s  ",day,month,year);
     }

     if (count == i)
     { 
      if (strlen(msg) < 2)  /* looking for blank line */
        {
           printf("</pre><hr><h2>%s\n<br>%s\n<br>%s\n<br></h2>\n<pre>",subject,from,date);
           printmessage(stream); 
           fclose(stream);
           return 0;
        }
       if (sscanf(msg,"From: %80c",from)>0) 
       {
          pt =  strchr(from,'\n'); 
          if (pt == NULL) 
             from[50] = '\0'; 
          else 
             *pt = '\0'; 
          pt = getname(from);
          if (pt != NULL)
              strcpy(from,pt);
          pt = strchr(from,'(');
          if (pt != NULL)          /*100*/
              *pt = '\0';
          pt = strchr(from,' ');
          if (pt != NULL)
              *pt = '\0';
         if (strlen(from) > 30) 
            from[50] = '\0'; 
         sprintf(temp,"From:    <a href=\"mailto:%s\">%s</a>",from,from);
         strcpy(from,temp);
       }

       if (sscanf(msg,"Subject: %80c",temp)>0) 
       {
          pt =  strchr(temp,'\n'); 
          if (pt == NULL) 
            temp[70] = '\0';  
          else 
            *pt = '\0';
           sprintf(subject,"Subject: %s", temp); 
        }
     }
  }
    fclose(stream);
   return 0;
}


char * getname(char * cp)
{
        char *cp1;

        if((cp = strchr(cp,'<')) == NULL)
                return NULL;
        cp++; /* cp -> first char of name */
        if((cp1 = strchr(cp,'>')) == NULL)
                return NULL;
        *cp1 = '\0';
        return cp;
}

int getmessagelist(char * name, char * area, char * search_name)
{
   FILE *stream;
   char date[80] = "";
   char from[255] = "";
   char subject[255] = "";
   char file_name[255] = "";
   char day[80] = "";
   char month[80] = "";
   char year[80] = "";
   char temp[255] = "";   /*150*/
   char msg[655] = "";
   char space[80];
   int count = 0;
   int i = 0;
   int j;
   char * pt;
   int found_word = FALSE;
   int no_search;
  
   if (search_name == NULL)
        no_search = TRUE;
   else
        no_search = FALSE;
 
 strcpy(file_name,strrchr(name,'/')+1);

    printf("<hr><h3>%s</h3>\n",file_name); 
    printf("<ol>");

 
   /* open a file for update */
   if ((stream = fopen(name, "r"))  == NULL)
   {
      printf("getmessagelist::Cannot open input file [%s].</ol>",file_name);
      return 1;
   }

while ( fgets(msg, sizeof(msg), stream) != NULL)
  {
       if (!no_search)
       {
         stringtolower(search_name);
         strcpy(temp,msg);
         stringtolower(temp);
         if (strstr(temp,search_name) != NULL)
         {
               found_word = TRUE;
               count++;
         }
       }

       if (strncmp("From ", msg, 5) == 0) 
       {
           i++;
           if (i>1 && (found_word || no_search)) printf("<li>%11s %-60s %s</li>\n", date,subject,from);
           day[0]     = '\0';  date[0] = '\0';
           from[0]    = '\0';  month[0] = '\0';
           subject[0] = '\0';  year[0]  = '\0'; 
           sscanf(msg,"From %s %s %s %s %s %s",temp,temp,month,day,temp,year);
           sprintf(date,"%2s%3s%-4s  ",day,month,year);
           msg[0]     = '\0';    
           found_word = FALSE;
       }
       if ((strlen(from) == 0) && (sscanf(msg,"From: %80c",from)>0))
       {
          pt =  strchr(from,'\n'); 
          if (pt == NULL)          /*200*/ 
             from[50] = '\0'; 
          else 
             *pt = '\0'; 
          pt = getname(from);
          if (pt != NULL)
              strcpy(from,pt);
          pt = strchr(from,'(');
          if (pt != NULL)
              *pt = '\0';
          pt = strchr(from,' ');
          if (pt != NULL)
              *pt = '\0';
         if (strlen(from) > 30) 
            from[50] = '\0'; 
         sprintf(temp,"<a href=\"mailto:%s\">%s</a>",from,from);
         strcpy(from,temp); 
       }

       if ( (strlen(subject) == 0) && (sscanf(msg,"Subject: %80c",temp)>0))
       {
          pt =  strchr(temp,'\n'); 
          if (pt == NULL) 
            temp[60] = '\0';  
          else 
            *pt = '\0';
          if (strlen(temp) > 60)
            temp[50] = '\0'; 
          for (j=0;j<60-strlen(temp);j++) 
                     space[j] = ' ';
          space[j] = '\0';
          sprintf(subject,"<a href=\"/cgi-bin/allmail.html?n1=%s&n2=%s&n3=%i\">%s</a>%s",
                         area,file_name,i,temp,space);
        }

  }
   if  (found_word || no_search)
        printf("<li>%11s %-60s %s</li>\n", date,subject,from);
    else if (count == 0)
        printf("No match for [%s] found in this archive.",search_name);
      printf("</ol>");
   fclose(stream);
   return 0;
}


int main(int argc, char ** argv)
{

   FILE *stream1;
   char archive_name[255] = "";
   char  getpath[255];
   int  msg_count = 0;
   char area_name[255] = "";
   char file_name[255] = "";

   switch(argc)
   { 
     case 4 : if (argv[3] != NULL) 
              msg_count = atoi(argv[3]);
     case 3 : if (argv[2] != NULL) 
              strcpy(file_name,argv[2]);   /* archive.seatcp.1234 */
     case 2 : if (argv[1] != NULL) 
              strcpy(area_name,argv[1]);   /* seatcp, tcpgroup, arrl */
              break;
 
     default: printf("<hr><center>main::nothing to do!</center><hr>");
              exit(0);
   }

  if (argc > 1)
  {
   sprintf(getpath,"ls -1 %s/%s/*archive.* > temp.txt",PATH,area_name);
/*   printf("[%s] [%s] %i\n",area_name,file_name,msg_count); */
  if (argc == 4)
     getmessage(area_name,file_name, msg_count); 
  else
   {
   if (system(getpath) == 0);
   {
     if ((stream1 = fopen("temp.txt", "r")) == NULL)
     {
      printf("<br>main::cannot fopen directory file list temp.txt. <br> Unable to open directory of filenames.</p>");
     }
     else
     {
        while ( fgets(archive_name, sizeof(archive_name), stream1) != NULL)
        {
           *strchr(archive_name,'\n') = '\0';
           /*printf("%s %s %s\n",archive_name,area_name,file_name);*/
           getmessagelist(archive_name,area_name,file_name);
        }
      }

    fclose(stream1);  /* close temp.txt */
    system("rm temp.txt");
   }
   }
  }
  return 0;
}
